# miniprogram-table-component

小程序自定义table组件
> 使用此组件需要依赖小程序基础库 2.2.2 版本，同时依赖开发者工具的 npm 构建。具体详情可查阅[官方 npm 文档](https://github.com/wechat-miniprogram/miniprogram-custom-component/blob/master/README.md)。

# 背景

针对上期打卡需求开发，这期需要以列表的形式展现打卡记录，但是微信小程序并没有table组件，可能是官方考虑到表格的功能的多样性，自定义配置较多就没有实现吧。现在没有现成的组件可以使用。针对这个问题，有两种解决方案：

- 内嵌 h5页面，（毕竟 h5 的 `table组件` 众多）
- 自定义 `table组件`（造轮子唄）

第一期打卡采用的原生开发的，老板期望第二期需求也能用原生，方便后期的维护。于是乎，我就开始了造轮子，该table组件需要满足一下功能：

- 主要用于展示结构化数据；
- 支持自定义操作、自定义表头样式，左右滚动等功能。

# 快速上手

一个简易的微信小程序 `table组件`诞生了。新鲜热乎的，先来看看展现效果，后面有使用介绍。
自定义的 table 组件，适用很简单，就是按照自定组件的用法使用。

### 1、引入
首先在页面对应的 `page.json`文件中配置。

```json
{
  "usingComponents": {
    "table": "../components/qsc-date-picker/index"
  }
}
```

### 2、使用

在wxml页面需要用到的地方使用，如下：

```html
<qsc-table  headers="{{tableHeader}}" list="{{row}}"  qsc-class-header="my-class" qsc-class-row="qsc-class-row" bind:rowHandle="onRowHandle"/>
```

### 3、配置

配置阶段主要配置config这个对象，这个对象中有这么几个属性，分别是


配置项 | 说明 | 类型  | 可选值 | 默认值 | 必填
---|---|---|---|---|---
headers | Array |---|---|
list | Arrray |---|---|
stripe | 是否为斑马纹 | boolean | true/false | false | 非
qsc-class-header | String |---|---|
qsc-class-row | String |---|---|
bind:rowHandle | Function |---|---|

stripe	 table	boolean	—	false

content --etable数据，数组类型，必填
titles --etable头部标题，数组类型，必填
props --etable每一列对应的数据的key值，
columnWidths --etable 每一列的列宽，值类型使用rpx，注意：(titles,props,columnWidths这3个数组的长度需保持一致)
border --etable 是否有边框，Boolean类型，默认true
stripe --etable 是否斑马纹，Boolean类型，默认true
headbgcolor --etable 标题栏的背景颜色，String类型，默认#ffffff(即白色)

配置相关代码：

```javascript

```

## 如何实现一个自定义表格组件？

#### 1、
#### 2、
#### 3、

## 源码

## 参考
- [微信小程序自定义table组件](https://www.jianshu.com/p/c48bbeb41739)
- [你期待的微信小程序表格组件来](https://juejin.im/post/5d901696f265da5b926bbcaa)

边框 border
标题栏自定义样式 headstyle
斑马线 stripe
分离样式
单元格宽度

组件代码